from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Int, Directory, File, Boolean

Seqfilters_V0_1_0 = CommandToolBuilder(tool="SeqFilters", base_command=["SeqFilters"], inputs=[ToolInput(tag="in_forward_primers", input_type=String(optional=True), prefix="--forward-primers", doc=InputDocumentation(doc="Comma seperated list of forward primers")), ToolInput(tag="in_max_forward", input_type=Int(optional=True), prefix="--max-forward", doc=InputDocumentation(doc="Maximum forward edit distance (default=2)")), ToolInput(tag="in_gene_name", input_type=Int(optional=True), prefix="--gene-name", doc=InputDocumentation(doc="Gene name, possible values are RRNA16S and\nOTHER (default=RRNA16S)")), ToolInput(tag="in_min_length", input_type=Int(optional=True), prefix="--min-length", doc=InputDocumentation(doc="Minimum sequence length after primer triming\n(default=0)")), ToolInput(tag="in_max_ns", input_type=Int(optional=True), prefix="--max-ns", doc=InputDocumentation(doc="Maxmimum number of Ns allowed in a sequence\n(default=0)")), ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="--outdir", doc=InputDocumentation(doc="Output directory (default=cwd)")), ToolInput(tag="in_result_dir_name", input_type=String(optional=True), prefix="--result-dir-name", doc=InputDocumentation(doc="Result dir name (default=result_dir)")), ToolInput(tag="in_keep_primer", input_type=String(optional=True), prefix="--keep-primer", doc=InputDocumentation(doc="Don't trim primers (default=false)")), ToolInput(tag="in_min_qual", input_type=Int(optional=True), prefix="--min-qual", doc=InputDocumentation(doc="Minimum sequence length after primer triming\n(default=20)")), ToolInput(tag="in_qual_file", input_type=File(optional=True), prefix="--qual-file", doc=InputDocumentation(doc="Quality input file (default=null)")), ToolInput(tag="in_reverse_primers", input_type=String(optional=True), prefix="--reverse-primers", doc=InputDocumentation(doc="Comma seperated list of reverse primers\n(default=null)")), ToolInput(tag="in_max_reverse", input_type=Int(optional=True), prefix="--max-reverse", doc=InputDocumentation(doc="Maximum reverse edit distance (default=0)")), ToolInput(tag="in_seq_file", input_type=File(optional=True), prefix="--seq-file", doc=InputDocumentation(doc="Sequence file to process")), ToolInput(tag="in_skip_not_ag", input_type=Boolean(optional=True), prefix="--skip-notag", doc=InputDocumentation(doc="Don't process no tag sequences")), ToolInput(tag="in_tag_file", input_type=File(optional=True), prefix="--tag-file", doc=InputDocumentation(doc="tag-file (default=null, no tag sorting)")), ToolInput(tag="in_max_length", input_type=Int(optional=True), prefix="--max-length", doc=InputDocumentation(doc="Maximum sequence length after primer triming\n(default=1000)\n")), ToolInput(tag="in_usage", input_type=String(), position=0, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="Output directory (default=cwd)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Seqfilters_V0_1_0().translate("wdl", allow_empty_container=True)

